#NoTrayIcon
;#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
;#AutoIt3Wrapper_icon=res\Chat.ico
;#AutoIt3Wrapper_Compression=4
;;#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
;#AutoIt3Wrapper_Run_Obfuscator=n
;#Obfuscator_Parameters=/sf 1 /sv 1
;#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.3.6.1
	Author:         Matwachich

	Script Function:
		Chat multi-clients/Serveur

#ce ----------------------------------------------------------------------------

#include <perso\TCP.au3>
#include <perso\GuiCtrlTexte.au3>
#include <perso\GUIExtender.au3>
#include <perso\AutoConfig.au3>
#include <perso\3StatIcon.au3>
#include <IE.au3>
#include <Sound.au3>

#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiStatusBar.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>
#include <ButtonConstants.au3>
#include <GuiHeader.au3>
#include <GuiImageList.au3>

Opt("MustDeclareVars", 1)

; ##############################################################


Global $__MainConfigDir = @AppDataDir & "\Mat's TCP Tchat"
Global $__MainConfigFile = $__MainConfigDir & "\c_cfg.ini"
Global $__SoundHndl_Msg
DirCreate($__MainConfigDir)

_extractRes($__MainConfigDir)
Global $__ResDll = $__MainConfigDir & "\res.dll"

If $CmdLine[0] = 1 And $CmdLine[1] = "/defaultConfig" Then FileDelete($__MainConfigFile)

#Region - ### Sounds ###
$__SoundHndl_Msg = _SoundOpen($__MainConfigDir & "\msg.wav")
#EndRegion ###

#region ### Config ###
_AutoCfg_Init($ACFG_Ini, $__MainConfigFile)
	_AutoCfg_AddEntry("ip", @IpAddress1)
	_AutoCfg_AddEntry("port", "8080")
	_AutoCfg_AddEntry("nick", "")
	_AutoCfg_AddEntry("historyDir", @ScriptDir & "\Historique")
	_AutoCfg_AddEntry("historyAutoSave", "1")
	_AutoCfg_AddEntry("replaceSelfNick", "1")
	_AutoCfg_AddEntry("graySelfMsg", "1")
	_AutoCfg_AddEntry("boldSelfMsg", "0")
	_AutoCfg_AddEntry("dsplMsgTime", "0")
	_AutoCfg_AddEntry("italSelfMsg", "0")
	_AutoCfg_AddEntry("highlightedContact", "")
	_AutoCfg_AddEntry("flashOnMsg", "1")
	_AutoCfg_AddEntry("soundOnMsg", "0")
_AutoCfg_ReadAll()
#endregion

Global $_C_VertFonce = "#00884C"
Global $_C_RougeFonce = "#EC2A00"
Global $_C_BleuFonce = "#000C9B"

#region ##### GUI Vars #####
Global $Main_GUI, $H_Display, $Input
Global $dB_send, $dB_refreshListe, $dB_GetLastSentText
Global $Lv_ClientsList, $statusBar
Global $nMsg
; --- Menu ---
Global $m_1, $m_2, $m_3
Global $m_connect, $m_disconnect, $m_identification, $m_quit
Global $m_flushChat, $m_saveHistory, $m_highlightContact, $m_highlightContactDisable
Global $m_cfg
; --- Header buttons ---
Global $BH_Connect, $BH_Disconnect, $BH_Identify, $BH_Config
Global $BH_Highlight, $BH_unHighlight
#endregion

#region ##### Globals #####
Global $__LastSentText
#endregion

Opt("GUICloseOnESC", 0)

#region ;### START Koda GUI section ###  ; ###################################################
$Main_GUI = GUICreate("TCP Chat - " & CFG("nick"), 467, 327 + 32 - 8)
_GUIExtender_Init($Main_GUI, 1)

#region ;# Menu # ; ##########################################################################
$m_1 = GUICtrlCreateMenu("Menu")
	$m_connect = GUICtrlCreateMenuItem("Connecter", $m_1)
	$m_disconnect = GUICtrlCreateMenuItem("Disconnect", $m_1)
	$m_identification = GUICtrlCreateMenuItem("Identification", $m_1)
	GUICtrlCreateMenuItem("", $m_1)
	$m_quit = GUICtrlCreateMenuItem("Quitter", $m_1)
$m_2 = GUICtrlCreateMenu("Chat")
	$m_flushChat = GUICtrlCreateMenuItem("Vider la fentre", $m_2)
	$m_saveHistory = GUICtrlCreateMenuItem("Sauvegarder la conversation", $m_2)
	GUICtrlCreateMenuItem("", $m_2)
	$m_highlightContact = GUICtrlCreateMenuItem("Surlign le contacte slection", $m_2)
	$m_highlightContactDisable = GUICtrlCreateMenuItem("Desactiver le surlignage", $m_2)
$m_3 = GUICtrlCreateMenu("Configuration")
	$m_cfg = GUICtrlCreateMenuItem("Paramtres", $m_3)
#endregion ;# Menu # ; ##########################################################################

#region ;# Display # ; #######################################################################
$H_Display = _GuiCtrlTexte_Create(8, 32, 281, 241, "white", "black", "consolas", "12")
$Input = GUICtrlCreateInput("", 8, 256 + 32 - 8, 281, 21)
#endregion ;# Display # ; #######################################################################

#region ;# Dummy # ; #########################################################################
$dB_send = GUICtrlCreateDummy()
$dB_refreshListe = GUICtrlCreateDummy()
$dB_GetLastSentText = GUICtrlCreateDummy()
#endregion ;# Dummy # ; #########################################################################

#region ;# Clients list # ; ##################################################################
_GUIExtender_Section_Start(300, 170)
	$Lv_ClientsList = GUICtrlCreateListView("Connects", 296, 32, 161, 268)

	$BH_Highlight = 	_3StatIcon_Create($__ResDll, 8, 297, 4, 24, 24, $__ResDll, 9, $__ResDll, 9)
		GUICtrlSetTip(-1, "Surligner le contacte selection")
		GUICtrlSetCursor(-1, 0)
		
	$BH_unHighlight =	_3StatIcon_Create($__ResDll, 10, 327, 4, 24, 24, $__ResDll, 11, $__ResDll, 11)
		GUICtrlSetTip(-1, "Desactiver le surlignage")
		GUICtrlSetCursor(-1, 0)
	
_GUIExtender_Section_End()
_GUIExtender_Section_Action(1, "<", ">", 270, 6, 19, 19, 0, 0, "Afficher/cacher la liste des contactes")

_GUICtrlListView_SetExtendedListViewStyle($Lv_ClientsList, $LVS_EX_FULLROWSELECT)
	_GUICtrlListView_SetColumnWidth($Lv_ClientsList, 0, 155)
	GUICtrlSetTip($Lv_ClientsList, 'Selectionez un contacte pour lui envoyer des messages privs')
#endregion ;# Clients list # ; ##################################################################

#region ;# Header # ; ########################################################################
$BH_Connect =		_3StatIcon_Create($__ResDll, 0, 7, 4, 24, 24, $__ResDll, 1, $__ResDll, 1)
	GUICtrlSetTip(-1, "Se connecter")
	GUICtrlSetCursor(-1, 0)

$BH_Disconnect =	_3StatIcon_Create($__ResDll, 2, 37 + 7, 4, 24, 24, $__ResDll, 3, $__ResDll, 3)
	GUICtrlSetTip(-1, "Se dconnecter")
	GUICtrlSetCursor(-1, 0)

$BH_Identify =		_3StatIcon_Create($__ResDll, 4, 67 + 14, 4, 24, 24, $__ResDll, 5, $__ResDll, 5)
	GUICtrlSetTip(-1, "S'identifier")
	GUICtrlSetCursor(-1, 0)

$BH_Config =		_3StatIcon_Create($__ResDll, 6, 97 + 21, 4, 24, 24, $__ResDll, 7, $__ResDll, 7)
	GUICtrlSetTip(-1, "Configuration")
	GUICtrlSetCursor(-1, 0)
#endregion ;# Header # ; ########################################################################

#region ;# Accelerators # ; ##################################################################
Dim $accelArray[4][2] = [["{enter}", $dB_send], _
		["{F6}", $dB_refreshListe], _
		["{F5}", $m_connect], _
		["{UP}", $dB_GetLastSentText]]
GUISetAccelerators($accelArray)
$accelArray = 0
#endregion ;# Accelerators # ; ##################################################################

$statusBar = _GUICtrlStatusBar_Create($Main_GUI)
GUISetState(@SW_SHOW)
#endregion ### END Koda GUI section ### ; ---------------------------------------------------

OnAutoItExitRegister('_onExitFunc')

Global $__ClientHandle = 0, $_signal = 0

_status("Deconnect!")
;_connect()

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE, $m_quit
			Exit
		Case $m_saveHistory
			_save()
		Case $m_flushChat
			_flush()

		Case $dB_send
			If GUICtrlRead($Input) = "" Then ContinueCase
			$__LastSentText = GUICtrlRead($Input)
			_send(GUICtrlRead($Input))
			GUICtrlSetData($Input, "")
			ControlClick($Main_GUI, "", $Input) ; To set focus
			
		Case $dB_GetLastSentText
			GUICtrlSetData($Input, $__LastSentText)
			
		Case $dB_refreshListe
			_sendCommande("lst", "", 1)
			
		Case $m_connect, $BH_Connect
			_connect()
		Case $m_disconnect, $BH_Disconnect
			_disconnect()
		Case $m_cfg, $BH_Config
			_config()
		Case $m_identification, $BH_Identify
			_SrvCmdHandle_idn()
		Case $m_highlightContact, $BH_Highlight
			_toggleHighlightContact(1)
		Case $m_highlightContactDisable, $BH_unHighlight
			_toggleHighlightContact(0)
			
	EndSwitch

	If _GUIExtender_Action($nMsg) Then _3StatIcon_ResetIcon()
WEnd

Func _status($text)
	_GUICtrlStatusBar_SetText($statusBar, $text)
EndFunc   ;==>_status

Func _send($text)
	Local $dest = _GUICtrlListView_GetItemTextString($Lv_ClientsList, -1)
	Switch $dest
		Case ""
			_sendCommande("msg", $text, 1)
		Case Else
			_sendCommande("prs", $dest & '##:##' & $text, 1)
	EndSwitch
EndFunc   ;==>_send

Func _connect($ip = Default, $port = Default, $nick = Default)
	If $__ClientHandle <> 0 Then Return _notif("Dj connect")
	If $ip = Default Then $ip = CFG("ip")
	If $port = Default Then $port = CFG("port")
	If $nick = Default Then $nick = CFG("nick")
	If $nick = "" Then Return _config()
	_disconnect()
	Sleep(500)
	; ---
	If Not _CheckIp($ip) Then $ip = TCPNameToIp($ip)
	If Not _CheckIp($ip) Then Return MsgBox(16, "Erreur", "Impossible de rsoudre le nom d'hote")
	; ---
	ConsoleWrite("+> Connecting As " & $nick & " @ " & $ip & ":" & $port & @CRLF)
	_status('Connexion  ' & $ip & ":" & $port & "...")
	$__ClientHandle = _TCP_Client_Create($ip, $port)
	_TCP_RegisterEvent($__ClientHandle, $TCP_CONNECT, "_REG_Connected")
	_TCP_RegisterEvent($__ClientHandle, $TCP_RECEIVE, "_TCP_Receive_PreProcess")
	_TCP_RegisterEvent($__ClientHandle, $TCP_DISCONNECT, "_REG_Disconnect")
	If Not _waitSignal(1000) Then Return _disconnect()
EndFunc   ;==>_connect

Func _REG_Connected($hSocket, $iError)
	ConsoleWrite("> Func: _REG_Connected" & @CRLF)
	_status("Connect!")
EndFunc   ;==>_REG_Connected

Func _REG_Disconnect($hSocket, $iError)
	ConsoleWrite("> Func _REG_Disconnect" & @CRLF)
	_notif("Connection perdue!")
	_disconnect()
EndFunc   ;==>_REG_Disconnect

Func _disconnect()
	ConsoleWrite("> Func: _disconnect" & @CRLF)
	_TCP_Client_Stop($__ClientHandle)
	$__ClientHandle = 0
	_status("Deconnect!")
EndFunc   ;==>_disconnect

Func _config()
	#Region - ### CFG GUI Var ###
	Local $Config_GUI, $I_ip, $I_port
	Local $I_nick, $I_HistDir, $C_HistAutoSave, $B_HistDirBrows
	Local $C_replaceSelfNick, $C_GraySelfMsg, $C_boldSelfMsg, $C_italSelfMsg, $C_DsplMsgTime, $C_soundOnMsg, $C_flashOnMsg
	Local $B_OK, $B_Cancel
	#EndRegion ###

	#region ### START Koda GUI section ### Form=
	$Config_GUI = GUICreate("Paramtres", 354, 298, -1, -1, -1, -1, $Main_GUI)

	GUICtrlCreateTab(8, 8, 337, 249)
		GUICtrlCreateTabItem("Systme")
			GUICtrlCreateGroup("Serveur", 24, 40, 305, 57)
				GUICtrlCreateLabel("IP", 32, 67, 14, 17)
				GUICtrlCreateLabel("Port", 152, 67, 23, 17)
				$I_ip = GUICtrlCreateInput(CFG("ip"), 48, 64, 97, 21)
				$I_port = GUICtrlCreateInput(CFG("port"), 176, 64, 49, 21, $ES_NUMBER)
			GUICtrlCreateGroup("", -99, -99, 1, 1)  ;close group

			GUICtrlCreateGroup("Identification", 24, 104, 305, 57)
				GUICtrlCreateLabel("Pseudo", 32, 131, 40, 17)
				$I_nick = GUICtrlCreateInput(CFG("nick"), 72, 128, 241, 21)
			GUICtrlCreateGroup("", -99, -99, 1, 1)  ;close group

			GUICtrlCreateGroup("Historique", 24, 168, 305, 73)
				GUICtrlCreateLabel("Dossier", 32, 195, 39, 17)
				$I_HistDir = GUICtrlCreateInput(CFG('historyDir'), 72, 192, 209, 21)
				$C_HistAutoSave = GUICtrlCreateCheckbox("Sauvegarder  la fermeture du programme", 32, 216, 249, 17)
					GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('historyAutoSave')))
				$B_HistDirBrows = GUICtrlCreateButton("", 288, 192, 27, 25, $WS_GROUP + $BS_ICON)
					GUICtrlSetImage(-1, "shell32.dll", -5, 0)
			GUICtrlCreateGroup("", -99, -99, 1, 1)  ;close group

		GUICtrlCreateTabItem("Prfrences")
			GUICtrlCreateGroup("Mes messages", 24, 40, 297, 105)
				$C_replaceSelfNick = GUICtrlCreateCheckbox('Remplacer mon pseudo par "Moi"', 40, 64, 177, 17)
					GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('replaceSelfNick')))
				$C_GraySelfMsg = GUICtrlCreateCheckbox("Griser mes messages", 40, 80, 177, 17)
					GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('graySelfMsg')))
				$C_boldSelfMsg = GUICtrlCreateCheckbox("Mettre mes messages en gras", 40, 96, 177, 17)
					GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('boldSelfMsg')))
				$C_italSelfMsg = GUICtrlCreateCheckbox("Mettre mes messages en italique", 40, 112, 177, 17)
					GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('italSelfMsg')))
			GUICtrlCreateGroup("", -99, -99, 1, 1)  ;close group

			$C_DsplMsgTime = GUICtrlCreateCheckbox("Afficher l'heur des messages", 40, 152, 177, 17)
				GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('dsplMsgTime')))
				
			$C_soundOnMsg = GUICtrlCreateCheckbox("Jouer un son (nouveau message)", 40, 168, 177, 17)
				GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('soundOnMsg')))
				
			$C_flashOnMsg = GUICtrlCreateCheckbox("Clignoter (nouveau message)", 40, 184, 177, 17)
				GUICtrlSetState(-1, _configStrToCheckBoxStat(CFG('flashOnMsg')))
	GUICtrlCreateTabItem("")

	$B_OK = GUICtrlCreateButton("OK", 176, 264, 75, 25, $WS_GROUP)
	$B_Cancel = GUICtrlCreateButton("Annuler", 264, 264, 75, 25, $WS_GROUP)

	Local $accelArray[2][2] = [["{enter}", $B_OK],["{esc}", $B_Cancel]]
	GUISetAccelerators($accelArray, $Config_GUI)

	GUISetState(@SW_SHOW)
	#endregion ### END Koda GUI section ###

	Local $nMsg, $R_ip, $R_port, $R_nick, $R_histDir, $_ColorTimer
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $B_Cancel
				ExitLoop
			Case $B_OK
				$R_ip = GUICtrlRead($I_ip)
				$R_port = GUICtrlRead($I_port)
				$R_nick = GUICtrlRead($I_nick)
				$R_histDir = GUICtrlRead($I_HistDir)

				#region ### Verif CFG ###
				DirCreate($R_histDir)
				If DirGetSize($R_histDir) = -1 Then
					GUICtrlSetBkColor($I_HistDir, 0xFFA29B)
					ContinueCase
				EndIf
				;If Not _checkIp($R_ip) Then
				;	GUICtrlSetBkColor($I_ip, 0xFFA29B)
				;	ContinueCase
				;EndIf
				If $R_port = "" Then
					GUICtrlSetBkColor($I_port, 0xFFA29B)
					ContinueCase
				EndIf
				If $R_nick = "" Then
					GUICtrlSetBkColor($I_nick, 0xFFA29B)
					ContinueCase
				EndIf
				#endregion ### Verif CFG ###

				#region ### Write et set CFG ###
				_AutoCfg_SetEntry("ip", $R_ip)
				_AutoCfg_SetEntry("port", $R_port)
				_AutoCfg_SetEntry("nick", $R_nick)
				_AutoCfg_SetEntry("historyDir", $R_histDir)
				_AutoCfg_SetEntry("historyAutoSave", _checkBoxStatToConfigStr(GUICtrlRead($C_HistAutoSave)))
				_AutoCfg_SetEntry("replaceSelfNick", _checkBoxStatToConfigStr(GUICtrlRead($C_replaceSelfNick)))
				_AutoCfg_SetEntry("graySelfMsg", _checkBoxStatToConfigStr(GUICtrlRead($C_GraySelfMsg)))
				_AutoCfg_SetEntry("boldSelfMsg", _checkBoxStatToConfigStr(GUICtrlRead($C_boldSelfMsg)))
				_AutoCfg_SetEntry("italSelfMsg", _checkBoxStatToConfigStr(GUICtrlRead($C_italSelfMsg)))
				_AutoCfg_SetEntry("dsplMsgTime", _checkBoxStatToConfigStr(GUICtrlRead($C_DsplMsgTime)))
				_AutoCfg_SetEntry("flashOnMsg", _checkBoxStatToConfigStr(GUICtrlRead($C_flashOnMsg)))
				_AutoCfg_SetEntry("soundOnMsg", _checkBoxStatToConfigStr(GUICtrlRead($C_soundOnMsg)))
				#endregion ### Write et set CFG ###

				WinSetTitle($Main_GUI, "", "TCP Chat - " & CFG("nick"))
				ExitLoop
		EndSwitch
	WEnd

	GUIDelete($Config_GUI)
	Return 1
EndFunc   ;==>_config

Func _TCP_Receive_PreProcess($hSocket, $sReceived, $iError)
	ConsoleWrite("+> Received Text: " & $sReceived & @CRLF)
	$sReceived = StringSplit($sReceived, "##FIN##", 1)
	For $i = 1 To $sReceived[0]
		If $sReceived[$i] <> "" Then _TCP_Receive($hSocket, $sReceived[$i], $iError)
	Next
EndFunc   ;==>_TCP_Receive_PreProcess

Func _TCP_Receive($hSocket, $sReceived, $iError)
	ConsoleWrite("+	Process: " & $sReceived & @CRLF)
	If StringRegExp(StringLeft($sReceived, 9), '##_..._##') Then Return _processServerCommande($sReceived)
	If Not StringInStr($sReceived, CFG("nick") & ' est connect!') Then
;~ 		If StringInStr($sReceived, '<b>[ ' & CFG("nick") & ' ]</b> ') Then
		If StringRegExp($sReceived, '<b>\[' & CFG("nick") & '\]</b>') Then
			If CFG("replaceSelfNick") = "1" Then
				$sReceived = StringReplace($sReceived, '<b>[' & CFG("nick") & ']</b>', '<b>[Moi]</b>')
			EndIf
			If CFG("graySelfMsg") = "1" Then
				$sReceived = StringReplace($sReceived, ']</b>', ']</b><font color=gray>')
				$sReceived = StringReplace($sReceived, '<br/>', '</font><br/>')
			EndIf
			If CFG("boldSelfMsg") = "1" Then
				$sReceived = StringReplace($sReceived, ']</b>', ']</b><b>')
				$sReceived = StringReplace($sReceived, '<br/>', '</b><br/>')
			EndIf
			If CFG("italSelfMsg") = "1" Then
				$sReceived = StringReplace($sReceived, ']</b>', ']</b><i>')
				$sReceived = StringReplace($sReceived, '<br/>', '</i><br/>')
			EndIf
		EndIf
		If CFG("dsplMsgTime") = "1" Then
			$sReceived = "<i>(" & @HOUR & ":" & @MIN & ":" & @SEC & ")</i>" & $sReceived
		EndIf
		If CFG("highlightedContact") Then
			$sReceived = StringReplace($sReceived, "[" & CFG("highlightedContact") & "]", '<span style="background:#000000;color:#FFFFFF">[' & CFG("highlightedContact") & "]</span>")
		EndIf
		_GuiCtrlTexte_Add($H_Display, $sReceived)
		_GuiCtrlTexte_ScrollDown($H_Display)
		_notifOnMsg()
	EndIf
EndFunc   ;==>_TCP_Receive

Func _processServerCommande($text)
	Local $cmd = StringMid($text, 4, 3)
	$text = StringTrimLeft($text, 9)
	Call("_SrvCmdHandle_" & $cmd, $text)
EndFunc   ;==>_processServerCommande

#region ##### Server Commands Handling #####
Func _SrvCmdHandle_idn($text = "")
	If $__ClientHandle = 0 Then Return _status("Vous n'tes pas connecter!")
	_sendCommande("idn", CFG("nick"), 0)
	_status("Connect et identifi en tant que " & CFG("nick"))
EndFunc   ;==>_SrvCmdHandle_idn

Func _SrvCmdHandle_lst($text)
	Local $i = 0
	While _GUICtrlListView_DeleteItem(GUICtrlGetHandle($Lv_ClientsList), $i)
		$i += 1
	WEnd
	Local $list = StringSplit($text, "|")
	For $i = 1 To $list[0]
		If $list[$i] <> CFG("nick") Then _GUICtrlListView_InsertItem($Lv_ClientsList, $list[$i])
	Next
EndFunc   ;==>_SrvCmdHandle_lst

Func _SrvCmdHandle_sgl($text)
	$_signal = 1
	AdlibRegister('_resetSignal', 1000)
EndFunc   ;==>_SrvCmdHandle_sgl

Func _SrvCmdHandle_dis($text)
	_notif("Deconnect pat le serveur! Raison: " & $text)
	_disconnect()
EndFunc   ;==>_SrvCmdHandle_dis
#endregion ##### Server Commands Handling #####

#region ##### History & Chat #####
Func _save()
	ConsoleWrite("+> Saving History..." & @CRLF)
	Local $dir = CFG('historyDir')
	If _GuiCtrlTexte_Read($H_Display, 0) <> "" Then
		DirCreate($dir)
		FileWrite($dir & "\" & @YEAR & @MON & @MDAY & "_" & @HOUR & @MIN & @SEC & ".html", _GuiCtrlTexte_Read($H_Display, 1))
	EndIf
EndFunc   ;==>_save

Func _flush()
	_GuiCtrlTexte_Clear($H_Display)
EndFunc   ;==>_flush

Func _toggleHighlightContact($flag)
	Switch $flag
		Case 1
			Local $cible = _GUICtrlListView_GetItemTextString($Lv_ClientsList, -1)
			If $cible Then
				_AutoCfg_SetEntry('highlightedContact', $cible)
			EndIf
		Case 0
			_AutoCfg_SetEntry('highlightedContact')
	EndSwitch
EndFunc   ;==>_toggleHighlightContact
#endregion ##### History & Chat #####

Func _sendCommande($cmd, $text, $verbose = 1)
	If $__ClientHandle = 0 Then
		If $verbose Then _notif("Vous n'tes pas connecter!", $_C_RougeFonce)
		Return
	EndIf
	Return _TCP_Send($__ClientHandle, '##_' & $cmd & '_##' & $text & '##FIN##')
EndFunc   ;==>_sendCommande

Func _notif($text, $color = 0)
	If $color <> 0 Then
		_GuiCtrlTexte_Add($H_Display, "- <i><font color='" & $color & "'>" & $text & "</font></i><br/>")
	Else
		_GuiCtrlTexte_Add($H_Display, "- <i>" & $text & "</i><br/>")
	EndIf
	_GuiCtrlTexte_ScrollDown($H_Display)
EndFunc   ;==>_notif

Func _resetSignal()
	$_signal = 0
	AdlibUnRegister('_resetSignal')
EndFunc   ;==>_resetSignal

Func _waitSignal($delay = 500)
	Local $timer = TimerInit()
	Do
		If $_signal = 1 Then Return 1
		Sleep(50)
	Until TimerDiff($timer) >= $delay
	Return 0
EndFunc   ;==>_waitSignal

Func _configStrToCheckBoxStat($str)
	If $str > 0 Then
		Return $GUI_CHECKED
	Else
		Return $GUI_UNCHECKED
	EndIf
EndFunc   ;==>_configStrToCheckBoxStat

Func _checkBoxStatToConfigStr($stat)
	If $stat = $GUI_CHECKED Then
		Return "1"
	Else
		Return "0"
	EndIf
EndFunc   ;==>_checkBoxStatToConfigStr

Func _checkIp($ip)
	$ip = StringSplit($ip, ".")
	If $ip[0] = 4 Then
		For $i = 1 To 4
			If $ip[$i] = "" Then Return 0
		Next
		Return 1
	Else
		Return 0
	EndIf
EndFunc   ;==>_checkIp

Func _notifOnMsg()
	If WinActive($Main_GUI) Then Return
	If CFG("flashOnMsg") Then WinFlash($Main_GUI)
	If CFG("soundOnMsg") Then _SoundPlay($__SoundHndl_Msg)
EndFunc

Func _extractRes($dir)
	FileInstall("c:\users\compaq\desktop\tcp\res\res.dll", $dir & "\res.dll", 1)
	FileInstall("c:\users\compaq\desktop\tcp\res\msg.wav", $dir & "\msg.wav", 1)
EndFunc

Func _onExitFunc()
	If CFG('historyAutoSave') = "1" Then _save()
	_SoundClose($__SoundHndl_Msg)
	_AutoCfg_SetEntry('highlightedContact')
	_disconnect()
EndFunc   ;==>_onExitFunc
