#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=res\server.ico
#AutoIt3Wrapper_Compression=4
;#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Run_Obfuscator=n
#Obfuscator_Parameters=/sf 1 /sv 1
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:
	Chat multi-clients/Serveur

#ce ----------------------------------------------------------------------------

#Include <perso\TCP.au3>
#include <perso\autoConfig.au3>
#include <perso\PasswordInput.au3>
#Include <Debug.au3>
#Include <SQLite.au3>
#include <SQLite.dll.au3>
#include <String.au3>

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GUIListBox.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

; ##########################################
Global $_C_VertFonce = "#00884C"
Global $_C_RougeFonce = "#EC2A00"
Global $_C_BleuFonce = "#000C9B"
Global $__SrvSocketHndl
; --- GUI ---
Global $Main_GUI, $C_ip, $I_port, $L_clients, $L_nbrClients, $B_kick, $B_reset, $I_MaxClients, $E_welcomMsg
; --- Tray ---
Global $Tray_Quit, $Tray_Cfg
; ##########################################

#region ### Config ###
_AutoCfg_Init($ACFG_Ini, @AppDataDir & "\Mat's TCP Tchat\s_cfg.ini")
	_AutoCfg_AddEntry("ip", @IPAddress1)
	_AutoCfg_AddEntry("port", "8080")
	_AutoCfg_AddEntry("welcomMsg", "Bienvenu")
	_AutoCfg_AddEntry("maxClients", 20)
_AutoCfg_ReadAll()
#endregion

Opt("TrayMenuMode", 11)
Opt("TrayOnEventMode", 1)

ConsoleWrite("! ----------------------------------------------- !" & @CRLF)

_SQLite_Startup()
_SQLite_Open()

_SQLite_Exec(-1, 'CREATE TABLE IF NOT EXISTS nicks (socket, nick UNIQUE ON CONFLICT FAIL)')

_StartServer()
_createGUI()
_createTray()

Global $_idenTimer = TimerInit()
While 1
	If TimerDiff($_idenTimer) >= 5000 Then
		; _allPing()
		_allIdn()
		$_idenTimer = TimerInit()
	EndIf
	Sleep(100)
WEnd

Func _StartServer()
	_TCP_Server_Stop()
	Sleep(1000)
	
	$__SrvSocketHndl = _TCP_Server_Create(CFG("port"), CFG("ip"))
	ConsoleWrite("+> Server started at " & CFG("ip") & ":" & CFG("port") & " (Return: " & $__SrvSocketHndl & ")" & @CRLF)

	_TCP_RegisterEvent($__SrvSocketHndl, $TCP_NEWCLIENT, "_TCP_NewClient")
	_TCP_RegisterEvent($__SrvSocketHndl, $TCP_RECEIVE, "_TCP_Receive_PreProcess")
	_TCP_RegisterEvent($__SrvSocketHndl, $TCP_DISCONNECT, "_TCP_Disconnect")
EndFunc

#region ##### TCP Functions #####
Func _TCP_NewClient($hSocket, $iError)
	ConsoleWrite("> Func _TCP_NewClient" & @CRLF) ; ### Debug
	If CFG("maxClients") <> -1 Then
		If _clients_GetNbr() >= CFG("maxClients") Then
			; _serverCommand('dis', 'Serveur plein', $hSocket) ; XXXXXXXXXXXXXXXXXXXXXXXX
			_serverNotif('Le serveur est plein!', $hSocket, $_C_RougeFonce)
			_TCP_Server_DisconnectClient($hSocket)
			_TCP_Disconnect($hSocket, 0)
		EndIf
	EndIf
	_SQLite_Exec(-1, 'INSERT INTO nicks VALUES (' & $hSocket & ', "")')
	_dsplDB()
	_serverCommand("sgl", "", $hSocket)
	_serverCommand("idn", "", $hSocket)
EndFunc

Func _TCP_Receive_PreProcess($hSocket, $sReceived, $iError)
	ConsoleWrite("> Func _TCP_Receive_PreProcess" & @CRLF) ; ### Debug
	ConsoleWrite("	" & $sReceived & @CRLF) ; ### Debug
	$sReceived = StringSplit($sReceived, "##FIN##", 1)
	For $i = 1 To $sReceived[0]
		If $sReceived[$i] <> "" Then _TCP_Receive($hSocket, $sReceived[$i], $iError)
	Next
EndFunc

Func _TCP_Receive($hSocket, $sReceived, $iError)
	ConsoleWrite("> Func _TCP_Receive" & @CRLF) ; ### Debug
	ConsoleWrite("	" & $sReceived & @CRLF) ; ### Debug
	If Not StringRegExp(StringLeft($sReceived, 9), '##_..._##') Then Return -1 ; all commands must be ##_cmd_##...text...
	Local $cmd = StringMid($sReceived, 4, 3)
	Call('_EventHandle_' & $cmd, $hSocket, StringTrimLeft($sReceived, 9))
EndFunc

Func _TCP_Disconnect($hSocket, $iError)
	ConsoleWrite("> Func _TCP_Disconnect" & @CRLF) ; ### Debug
	Local $nick = _socketToNick($hSocket)
	ConsoleWrite("	" & $nick & " (" & $hSocket & ")" & @CRLF) ; ### Debug
	If $nick <> "Inconnu" Then _serverNotif($nick & ' est deconnect!', 'broadcast', $_C_RougeFonce)
	_SQLite_Exec(-1, 'DELETE FROM nicks WHERE socket=' & $hSocket)
	_dsplDB()
	_sendClientsList()
EndFunc
#endregion

#region ##### Registered Funcs #####
Func _EventHandle_msg($hSocket, $text)
	ConsoleWrite("> Func _EventHandle_msg" & @CRLF) ; ### Debug
	Local $nick = _socketToNick($hSocket)
	If $nick = "Inconnu" Then Return _serverNotif('Vous devez vous identifier', $hSocket, $_C_RougeFonce)
	$text = StringRegExpReplace($text, '<|>|\[|\]', '</i>?</i>')	; ### Replace les balise HTML et les [] par ? (italique)
	_TCP_Server_Broadcast('<b>[' & $nick & ']</b> ' & $text & '<br/>##FIN##')
EndFunc

Func _EventHandle_idn($hSocket, $text)
	ConsoleWrite("> Func _EventHandle_idn" & @CRLF) ; ### Debug
	Local $oldNick = _socketToNick($hSocket)
	ConsoleWrite("	" & $oldNick & " => " & $text & @CRLF) ; ### Debug
	If _SQLite_Exec(-1, 'UPDATE nicks SET nick="' & $text & '" WHERE socket=' & $hSocket) <> $SQLITE_OK Then
		_TCP_Disconnect($hSocket, 0)
		; _serverCommand('dis', $text & ' est dj utilis!', $hSocket) ; XXXXXXXXXXXXXXXXXXXXXXXX
		_serverNotif('Votre pseudo est dj utilis!', $hSocket, $_C_RougeFonce)
		_TCP_Disconnect($hSocket, 0)
		Return _TCP_Server_DisconnectClient($hSocket)
	EndIf
	If $oldNick <> "Inconnu" And $oldNick <> $text Then
		_serverNotif($oldNick & ' devien ' & $text, 'broadcast', $_C_BleuFonce)
	ElseIf $oldNick <> $text Then
		_serverNotif($text & ' est connect!', 'broadcast', $_C_BleuFonce)
		_serverNotif(CFG("welcomMsg"), $hSocket, $_C_VertFonce)
	ElseIf $oldNick = $text Then
		Return _serverNotif('Vous tes dj identifi!', $hSocket, $_C_BleuFonce)
	EndIf
	_sendClientsList()
	_dsplDB()
EndFunc

Func _EventHandle_prs($hSocket, $text)
	ConsoleWrite("> Func _EventHandle_prs" & @CRLF) ; ### Debug
	Local $split = StringSplit($text, '##:##', 1)
	Local $destSock = _nickToSocket($split[1])
	Local $senderNick = _socketToNick($hSocket)
	Local $msg = $split[2]
	ConsoleWrite("	" & $senderNick & " => " & $split[1] & " : " & $msg & @CRLF)
	$msg = StringRegExpReplace($msg, '<|>', '</i>?</i>')	; ### Replace les balise HTML par ? (italique)
	_TCP_Send($destSock, '<b><font color=gray>(P)</font>[' & $senderNick & ']</b> ' & $msg & '<br/>##FIN##')
	_TCP_Send($hSocket, '<b><font color=gray>(P)</font>[' & $senderNick & ' => ' & $split[1] & ']</b> ' & $msg & '<br/>##FIN##')
EndFunc

Func _EventHandle_lst($hSocket, $text)
	_sendClientsList($hSocket)
EndFunc
#endregion

#region ##### Server Functions #####
Func _sendClientsList($destSocket = "broadcast")
	ConsoleWrite("> Func _sendClientsList" & @CRLF) ; ### Debug
	Local $hQuery, $aRow, $retList = ""
	_SQLite_Query(-1, 'SELECT nick FROM nicks', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		$retList &= $aRow[0] & "|"
	WEnd
	_SQLite_QueryFinalize($hQuery)
	$retList = StringTrimRight($retList, 1)
	_CFG_FillClientsList()
	_serverCommand('lst', $retList, $destSocket)
EndFunc

Func _allIdn()
;~ 	ConsoleWrite("> Func _allIdn" & @CRLF) ; ### Debug
	Local $hQuery, $aRow
	_SQLite_Query(-1, 'SELECT socket FROM nicks WHERE nick=""', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		_serverCommand('idn', "", $aRow[0])
	WEnd
	_SQLite_QueryFinalize($hQuery)
EndFunc

Func _serverNotif($text, $destSocket = "broadcast", $color = "#000000")
	ConsoleWrite("> Func _serverNotif" & @CRLF) ; ### Debug
	If $destSocket = "broadcast" Then
		_TCP_Server_Broadcast('<b>SERVER:</b> <font color=' & $color & '>' & $text & '</font><br/>##FIN##')
	Else
		_TCP_Send($destSocket, '<b>SERVER:</b> <font color=' & $color & '>' & $text & '</font><br/>##FIN##')
	EndIf
	ConsoleWrite("	" & _socketToNick($destSocket) & " (" & $destSocket & "): " & $text & @CRLF) ; ### Debug
	Sleep(200)
EndFunc

Func _serverCommand($cmd, $text = "", $destSocket = "broadcast")
	ConsoleWrite("> Func _serverCommand" & @CRLF) ; ### Debug
	Local $toSend = "##_" & $cmd & "_##" & $text
	_DebugOut("CMD: " & $destSocket & " => " & $toSend)
	If $destSocket = "broadcast" Then
		_TCP_Server_Broadcast($toSend & "##FIN##")
	Else
		_TCP_Send($destSocket, $toSend & "##FIN##")
	EndIf
	ConsoleWrite("	" & _socketToNick($destSocket) & " (" & $destSocket & "): " & $cmd & " - " & $text & @CRLF) ; ### Debug
	Sleep(200)
EndFunc

Func _clients_GetNbr()
	ConsoleWrite("> Func _clients_GetNbr" & @CRLF) ; ### Debug
	Local $hQuery, $aRow, $nbr = 0
	_SQLite_Query(-1, 'SELECT COUNT(*) FROM nicks', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		$nbr = $aRow[0]
	WEnd
	_SQLite_QueryFinalize($hQuery)
	ConsoleWrite("	" & $nbr & @CRLF)
	Return $nbr
EndFunc
#endregion

#region ##### Sockets & Nicknames #####
Func _socketToNick($hSocket)
;~ 	ConsoleWrite("> Func _socketToNick" & @CRLF) ; ### Debug
	If $hSocket = "broadcast" Then Return "broadcast"
	Local $hQuery, $aRow, $sNick
	_SQLite_Query(-1, 'SELECT nick FROM nicks WHERE socket=' & $hSocket & ' LIMIT 1', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		$sNick = $aRow[0]
	WEnd
	_SQLite_QueryFinalize($hQuery)
	If $sNick = "" Then $sNick = "Inconnu"
;~ 	ConsoleWrite("	" & $hSocket & " = " & $sNick & @CRLF) ; ### Debug
	Return $sNick
EndFunc

Func _nickToSocket($nick)
;~ 	ConsoleWrite("> Func _nickToSocket" & @CRLF) ; ### Debug
	Local $hQuery, $aRow, $hSocket = 0
	_SQLite_Query(-1, 'SELECT socket FROM nicks WHERE nick="' & $nick & '" LIMIT 1', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		$hSocket = $aRow[0]
	WEnd
	_SQLite_QueryFinalize($hQuery)
	If $hSocket = 0 Then $hSocket = "Inconnu"
;~ 	ConsoleWrite("	" & $nick & " = " & $hSocket & @CRLF) ; ### Debug
	Return $hSocket
EndFunc
#endregion

#Region - ### GUI & Tray ###
Func _createGUI()
	$Main_GUI = GUICreate("Mat's TCP Tchat Server", 262, 343)
	$C_ip = GUICtrlCreateCombo("", 90, 20, 145, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	$I_port = GUICtrlCreateInput("", 90, 45, 71, 21)
	$L_clients = GUICtrlCreateList("", 90, 200, 146, 110)
	GUICtrlCreateLabel("IP du serveur", 15, 23, 67, 17)
	GUICtrlCreateLabel("Port", 15, 48, 23, 17)
	GUICtrlCreateLabel("Clients", 15, 200, 35, 17)
	$B_kick = GUICtrlCreateButton("Kick", 15, 220, 60, 20)
	$B_reset = GUICtrlCreateButton("Reset", 90, 95, 70, 20)
	$L_nbrClients = GUICtrlCreateLabel("Clients connects", 120, 315, 113, 17)
	$I_MaxClients = GUICtrlCreateInput("", 90, 70, 71, 21, BitOR($ES_AUTOHSCROLL,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	$E_welcomMsg = GUICtrlCreateEdit("", 90, 125, 146, 71, BitOR($ES_MULTILINE,$ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_WANTRETURN,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD), $WS_EX_STATICEDGE)
	GUICtrlCreateLabel("Max clients", 15, 72, 57, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlCreateLabel("Rinitialiser", 15, 98, 57, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlCreateLabel("Message de", 15, 123, 62, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlCreateLabel("bienvenu", 20, 140, 48, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
EndFunc

Func _createTray()
	$Tray_Cfg = TrayCreateItem("Configuration")
		TrayItemSetOnEvent(-1, "_Tray_Event_Cfg")
	$Tray_Quit = TrayCreateItem("Quitter")
		TrayItemSetOnEvent(-1, "_Tray_Event_Quit")
EndFunc

Func _Tray_Event_Cfg()
	Local $iplist = @IPAddress1 & "|" & @IPAddress2 & "|" & @IPAddress3 & "|" & @IPAddress4
	GuiCtrlSetData($C_ip, "")
	GuiCtrlSetData($C_ip, $iplist, CFG("ip"))
	GuiCtrlSetData($I_port, CFG("port"))
	GuiCtrlSetData($E_welcomMsg, CFG("welcomMsg"))
	GuiCtrlSetData($I_MaxClients, CFG("maxClients"))
	; ---
	GuiCtrlSetData($L_nbrClients, _clients_GetNbr() & " Clients connects")
	_CFG_FillClientsList()
	GUISetState(@SW_SHOW, $Main_GUI)
	; ---
	Local $tmp
	While 1
		Switch GuiGetMsg()
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $B_kick
				$tmp = _nickToSocket(GuiCtrlRead($L_Clients))
				_TCP_Disconnect($tmp, 0)
				_TCP_Server_DisconnectClient($tmp)
				_CFG_FillClientsList()
			Case $B_reset
				If Not _CheckIp(GuiCtrlRead($C_ip)) Then ContinueCase
				_AutoCfg_SetEntry("ip", GuiCtrlRead($C_ip))
				_AutoCfg_SetEntry("port", GuiCtrlRead($I_port))
				_AutoCfg_SetEntry("welcomMsg", GuiCtrlRead($E_welcomMsg))
				_AutoCfg_SetEntry("maxClients", GuiCtrlRead($I_MaxClients))
				MsgBox(64, "Information", "Rinitialisation du serveur avec les nouveaux paramtres...")
				_disconnect_all_clients()
				_CFG_FillClientsList()
				_StartServer()
		EndSwitch
	WEnd
	GUISetState(@SW_HIDE, $Main_GUI)
EndFunc

Func _disconnect_all_clients()
	Local $hQuery, $aRow, $hSocket = 0
	_SQLite_Query(-1, 'SELECT socket FROM nicks', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		_TCP_Server_DisconnectClient($aRow[0])
	WEnd
	_SQLite_QueryFinalize($hQuery)
	; ---
	_SQLite_Exec(-1, 'DROP TABLE nicks')
	_SQLite_Exec(-1, 'CREATE TABLE IF NOT EXISTS nicks (socket, nick UNIQUE ON CONFLICT FAIL)')
	GuiCtrlSetData($L_nbrClients, _clients_GetNbr() & " Clients connects")
EndFunc

Func _CFG_FillClientsList()
	GuiCtrlSetData($L_Clients, "")
	Local $hQuery, $aRow, $hSocket = 0
	_SQLite_Query(-1, 'SELECT nick FROM nicks', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		GuiCtrlSetData($L_Clients, $aRow[0] & "|", 1)
	WEnd
	_SQLite_QueryFinalize($hQuery)
	GuiCtrlSetData($L_nbrClients, _clients_GetNbr() & " Clients connects")
EndFunc

Func _CheckIp($ip)
	Return StringRegExp($ip, '\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}')
EndFunc

Func _Tray_Event_Quit()
	If MsgBox(36, "Confirmation", "Voulez-vous vraiment quitter le serveur?" & @CRLF _ 
	& "(Tous les clients perdront la connexion)") = 6 Then Exit
EndFunc
#EndRegion ###

#region ##### DEBUG #####
Func _dsplDB()
	Local $hQuery, $aRow
	ConsoleWrite("& ---------------------------------- &" & @CRLF)
	_SQLite_Query(-1, 'SELECT ROWID,* FROM nicks', $hQuery)
	While _SQLite_FetchData($hQuery, $aRow) = $SQLITE_OK
		For $i In $aRow
			ConsoleWrite($i & " -" & @TAB)
		Next
		ConsoleWrite(@CRLF)
	WEnd
	_SQLite_QueryFinalize($hQuery)
	ConsoleWrite("& ---------------------------------- &" & @CRLF)
EndFunc
#endregion